#ifndef _scanner_h
#define _scanner_h

class argstream {
	private:
		unsigned int Idx;
		std::string  CmdLine;
	
	public:
		int Arg;
	
	public:
		argstream(int arg, int argn, const char *argv[])
			: Idx(0), Arg(arg) { CmdLine = catArgs(arg, argn, argv); }
		argstream(int arg, const char *cmdline)
			: Idx(0), CmdLine(cmdline), Arg(arg) {}
		
		int peek() { return Idx<CmdLine.length() ? CmdLine[Idx  ] : -1 ; }
		int get()  { return Idx<CmdLine.length() ? CmdLine[Idx++] : -1 ; }
	
	private:
		std::string catArgs(int arg, int argn, const char *argv[]);
};

struct tokens {
	enum { ERR=256, INUM, DNUM, ONAME }; // int, double, key word
	
	int         type;
	std::string val;
};

class scanner {
	private:
		tokens      Token;
		bool        Peek;
		argstream & In;
	
	public:
		scanner(argstream & in) : Peek(false), In(in) {}
		tokens peek();
		tokens get();
};

#endif
